"""
    ai/h2o/engine/v1/engine_service.proto

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: version not set
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from h2o_engine_manager.gen.engine_service.api_client import ApiClient, Endpoint as _Endpoint
from h2o_engine_manager.gen.engine_service.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from h2o_engine_manager.gen.engine_service.model.rpc_status import RpcStatus
from h2o_engine_manager.gen.engine_service.model.v1_list_engines_response import V1ListEnginesResponse


class EngineServiceApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.engine_service_list_engines_endpoint = _Endpoint(
            settings={
                'response_type': (V1ListEnginesResponse,),
                'auth': [],
                'endpoint_path': '/v1/{parent}/engines',
                'operation_id': 'engine_service_list_engines',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'parent',
                    'page_size',
                    'page_token',
                    'order_by',
                    'filter',
                ],
                'required': [
                    'parent',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'parent',
                ]
            },
            root_map={
                'validations': {
                    ('parent',): {

                        'regex': {
                            'pattern': r'workspaces\/[^\/]+',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'parent':
                        (str,),
                    'page_size':
                        (int,),
                    'page_token':
                        (str,),
                    'order_by':
                        (str,),
                    'filter':
                        (str,),
                },
                'attribute_map': {
                    'parent': 'parent',
                    'page_size': 'pageSize',
                    'page_token': 'pageToken',
                    'order_by': 'orderBy',
                    'filter': 'filter',
                },
                'location_map': {
                    'parent': 'path',
                    'page_size': 'query',
                    'page_token': 'query',
                    'order_by': 'query',
                    'filter': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def engine_service_list_engines(
        self,
        parent,
        **kwargs
    ):
        """Returns a collection of Engines within a workspace.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.engine_service_list_engines(parent, async_req=True)
        >>> result = thread.get()

        Args:
            parent (str): Workspace resource name. Format: workspaces/{workspace}

        Keyword Args:
            page_size (int): Maximum number of Engines to return in a response. If unspecified (or set to 0), at most 50 Engines will be returned. The maximum value is 1000; values above 1000 will be coerced to 1000.. [optional]
            page_token (str): Leave unset to receive the initial page. To list any subsequent pages use the value of 'next_page_token' returned from the ListEnginesResponse.. [optional]
            order_by (str): Used to specify the sorting order.  When unset, Engines are ordered by their time of creation in descending order. This is equivalent to \"create_time desc\".  When specified, the value must be a comma separated list of supported fields. The supported fields are: {name, version, cpu, gpu, memory_bytes, storage_bytes, creator, create_time, update_time, delete_time, resume_time, display_name, uid}  The default sorting order is ascending. For example: \"name\" and \"name asc\" are equivalent values.  To specify descending order for a field, append a \" desc\" suffix. For example: \"name desc\".  Redundant space characters are insignificant. For example these values are all equal: - \"  name, cpu     desc\" - \"name, cpu desc\" - \"name   , cpu desc   \". [optional]
            filter (str): Used to filter Engines.  When unset, no filtering is applied.  When specified, the filter string must follow this formatting rules: filter expression: [term] AND [term] AND [term] ... term: [filter_field] [operator] [value] filter_field: (name|version|state|cpu|gpu|memory_bytes|storage_bytes|creator|create_time|update_time|delete_time|resume_time|reconciling|uid|display_name|type) operator: (=|!=|<=|<|>=|>) value: ([text]|[string]) text: free-form set of characters without whitespace (WS) or . (DOT) within it. (e.g. `28`, `abc`, `@5_6_7$`) string: a quoted string. Text may contain whitespace (WS) or . (DOT) within it. (e.g. `\"28\"`, `\"abc\"`, `\"@5_6_7$\"`, `\"   foo .  \"`)  Filter expression is case sensitive. Additional constraints: - You MUST use separator `<space>AND<space>` between terms. - String value MUST NOT contain `<space>AND<space>`.  Each field may support only some operators: - string fields (name, version, creator, uid) support: =, !=, <=, <, >=, > - number fields (cpu, gpu, memory_bytes, storage_bytes) support: =, !=, <=, <, >=, > - bool fields (reconciling) support: =, != - enum fields (state, type) support: =, != - time fields (create_time) support: =, !=, <=, <, >=, > - version fields (version) support: =, !=, <=, <, >=, >  Each field may expect values in a specified format: - string fields expect: text or string. For example `foo`, `\"f oo\"`. For example `f oo` is invalid. - number fields expect: numbers (can be wrapped in parentheses). For example: `28`, `-100`, `56.8`, `\"666\"` - integer number fields expect: integers. For example: `cpu = 10.5` is invalid. - bool fields expect: `true` or `false` literals. For example: `reconciling = true` is valid. `reconciling = 1` or `reconciling = TRUE` is invalid. - enum fields expect: enum's string representation. For example `state = STATE_RUNNING` is valid. `state = RUNNING` or `state = state_running` is invalid. - time fields expect: RFC-3339 formatted string. UTC offsets are supported. For example `2012-04-21T11:30:00-04:00` is valid. `2012-04-21` is invalid. - version fields expect: version identifier. Aliases are NOT accepted. For example: `1.10.1` is valid. `latest` or `abc` is invalid.   If version identifier is not in semver format, then it may not be accepted.  Valid filter expression examples: - `state = STATE_RUNNING AND cpu <= 5 AND gpu != 0 AND create_time > 2012-04-21T11:30:00-04:00` - `state=STATE_RUNNING AND cpu<=5` (there may be no whitespace between term parts: `[filter_field][operator][value]`)  Invalid filter expression examples: - `state = STATE_RUNNING    AND    cpu <= 5` (invalid separator between terms) - `state = STATE_RUNNING OR cpu <= 5` (unsupported logical operator) - `(state = STATE_RUNNING) AND (cpu <= 5)` (unsupported parentheses). [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            V1ListEnginesResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['parent'] = \
            parent
        return self.engine_service_list_engines_endpoint.call_with_http_info(**kwargs)

